-- NURBS Curve to SplineShape Converter BETA
-- by Jarek Dukat
-- http://www.nautilus.com.pl/jarek
-- jarek@nautilus.com.pl

global shp_converted, shp_sel

-- Utility definition
utility convertcurve "NURBS Curve Converter"
(
	pickbutton convcurve "Pick NURBS Curve" filter:validcurve width:140 height:19

-- about labels
	label ab1 "NURBS Curve" offset:[0,10]
	label ab2 "to Spline Shape Converter"
	label ab3 "BETA VERSION 0.9" offset:[0,5]
	label ab4 "by Jarek Dukat" offset:[0,5]
	label ab5 "http://www.www.nautilus.com.pl/jarek"
	label ab6 "jarek@nautilus.com.pl"

-- picked NURBS curve handler
	on convcurve picked node do
	(
		shp_converted = #()
		shp_sel = #()
		nset = getnurbsset node
		for i = 1 to nset.numobjects do
		(
			nset = getnurbsset node
			nsetobj = getobject nset i
-- convert to shape if NURBSCurve:
			if (ClassOf nsetobj == nurbscvcurve) or (ClassOf nsetobj == point_curve) do doconvcurve nset i node.pos node.name
		)

-- prepare text for messageBox
		if shp_converted.count == 1 then
			txt = "NURBS Curve \"" + node.name + "\" successfully converted to Spline Shape \"" + shp_converted[1] + "\"."
		else
		(
			txt = "NURBS Curve \"" + node.name + "\" successfully converted to multiple Spline Shapes:\n"
			for i = 1 to shp_converted.count do
				txt += (i as string) + ": \"" + shp_converted[i] + "\";\n"
		)
		messagebox txt title:"Convert Relults" beep:false
		select shp_sel
	)
)

-- verify if the picked object is a NURBS curve
fn validcurve obj = (ClassOf obj == cv_curve) or (ClassOf obj == point_curve)

-- convertion procedure
fn doconvcurve ns nc np nm =
(
-- extract one curve from NURBS Set
	num = ns.numobjects
	for n = 1 to (nc-1) do removeobject ns 1
	for n = (nc+1) to num do removeobject ns 2
-- copy one curve to separate object
	nn = nurbsnode ns name:"tmpcurve" pos:np
	converttonurbscurve nn
	addmodifier nn (extrude capStart:false capEnd:false segs:1 amount:0 output:1)
	ncnm = if nc>9 then (nc as string) else ("0" + (nc as string))
-- create new shape and convert curve
	shp = splineshape name:(nm + " Converted " + ncnm) pos:nn.pos
	spln = addnewspline shp
	for s = 1 to (getnumverts nn) / 2 do addknot shp spln #smooth #curve (getvert nn s)
	updateshape shp
	shp_converted[(shp_converted.count + 1)] = shp.name
	delete nn
	shp_sel[nc] = shp
)
